var stdTimeout = 1000;

app.controller('GridViewController', function($scope, $http, $timeout, $q, $interval, ngDialog) {

    $scope.gridId = "igniteGridId";

    var levelEnums = {
        Total: -1,
        Analytics: 0,
        Underlier: 1,
        Positions: 2
    };
	
    function getIgniteGridConfig(columns) {
        
		return {
            width: $(window).width() - 20,
            height: $(window).height() - 220,
            autoCommit: true,
            dataSource: [],
            columns: columns,
            autoGenerateColumns: false,
            primaryKey: "Id",
            childDataKey: "Children",
            initialExpandDepth: 1,
            defaultColumnWidth: 150,
            showFirstLastPages: false,
            showPrevNextPages: false,
            enableHoverStyles: false,
            rowVirtualization: true,
            virtualizationMode: "continuous",
            features: [{
                mode: "multiple",
                name: "Selection",
                mode: "row",
                multipleSelection: true
            }, {
                name: "Resizing"
            }, {
                name: "Hiding",
                columnSettings: [{
                    columnKey: 'Id',
                    allowHiding: false
                }, {
                    columnKey: 'LevelType',
                    allowHiding: false
                }]
            }, {
                name: "Filtering",
                mode: "simple"
            }, {
                name: "Tooltips",
                style: "tooltip",
                visibility: "overflow"
            }, {
                name: "Sorting",
                type: 'local',
                mode: "multiple",
                columnSettings: [{
                    columnKey: "Name",
                    allowSorting: true,
                    currentSortDirection: "ascending"
                }]
            }, {
                name: "ColumnMoving",
                columnDragEnd: function(evt, args) {
                    columnDFunction(evt, args);
                }
            }, {
                name: "ColumnFixing",
                fixingDirection: "left"
            }, {
                name: "Updating",
                editMode: "none",
                enableAddRow: false,
                enableAddChild: false,
                showDoneCancelButtons: false,
                enableDeleteRow: false,
                enableDataDirtyException: false
            }]
        };
    }

    function cleanName(name) {
        return name.replace(/[^a-zA-Z0-9]/ig, ''); //change all characters except numbers and letters
    }

    function initializeIgniteGrid() {
        var columns = [{
            key: "Id",
            dataType: "number",
            hidden: true
        }, {
            key: 'LevelType',
            dataType: "number",
            hidden: true
        }, {
            width: 300,
            key: "Name",
            headerText: "Name",
            dataType: "string"
        }, {
            width: 200,
            key: "Description",
            dataType: "string",
            headerText: "Description"
        }, {
            width: 120,
            key: "Quantity",
            dataType: "number",
            format: "number",
            headerText: "Quantity"
        }];

        //create grid columns
        for (var i = 0; i < $scope.gridView.analytics.length; i++) {

            var name = cleanName($scope.gridView.analytics[i].name),
                colProp = {
                    key: name,
                    headerText: $scope.gridView.analytics[i].display,
                    dataType: "number",
                    format: "currency"
                };
				
            columns.push(colProp);
        }

		$scope.gridOptionsForIgnite = getIgniteGridConfig(columns);
        $scope.hasGridOptionsForIgnite = true;
    }
	
    $scope.tick = function() {

        stdTimeout = 4000;
            
            var requests = [
                generateTagAnalyticRequest(analyticNames),
                generatePositionAnalyticRequest(positionAnalyticNames),
                generateUnderlierAnalyticRequest(analyticNames)
            ];

            $q.all(requests).then(function(results) {

                totalRow.Children = results;
                $scope.totalRow = totalRow;
                $scope.gridOptionsForIgnite.dataSource = [totalRow];

            });

            if (!$scope.hasGridOptionsForIgnite) {
                initializeIgniteGrid();
            }
			
        $timeout(function() {
            $scope.tick();
        }, stdTimeout);
    };

    $scope.tick();

});